<?php

/***************************************************************************
 *                              functions_news.php
 *                            -------------------
 *   begin                : Monday, January 13th 2003
 *   email                : webmaster@codemonkeyx.net
 *
 *
 ***************************************************************************/
if (!defined('IN_PHPBB'))
{
	die('Hacking attempt');
}

if($phpbb_root_path != "./" && $phpbb_root_path != '../' && $phpbb_root_path != './../')
{
  die("Hacking attempt (Path)");
  $phpbb_root_path = './';
}


include_once( $phpbb_root_path . 'includes/bbcode.php' );

function fetch_recent_news( $num_items, $news_id = 0, $forum_id = 0,
                              $title_trim = 0,
                              $trim_append_title = '' )
// $num_items: Number of news items to return.
// $news_title_trim: Number of characters to trim title to. (0 = disabled)
// $trim_append_title: What to attach to the end of a trimed title.
// $forum_id: Only retrive news in this forum. (0 = disabled)
{
	global $db, $userdata, $phpbb_root_path, $board_config, $phpEx;
	
	$sql = 'SELECT
			t.*
		FROM
			' . TOPICS_TABLE     . ' AS t,
			' . POSTS_TABLE      . ' AS p
		WHERE
			t.topic_last_post_id = p.post_id AND
			t.news_id > 0 ';

	if( $news_id > 0 )
	{
		$sql .= 'AND t.news_id = ' . $news_id . ' ';
	}

	if( $forum_id > 0 )
	{
		$sql .= 'AND t.forum_id = ' . $forum_id . ' ';
	}

	$sql .= 'ORDER BY
			p.post_time DESC
		LIMIT 0, ' . $num_items;

	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'Could not query forum news information', '', __LINE__, __FILE__, $sql);
	}

	$topics = array( );
	$recent_items = array();
	while( $row = $db->sql_fetchrow($result) )
	{
		if( !in_array( $row['topic_id'], $topics ) )
		{
			// Trim the news title if needed.
			if( $title_trim > 0 )
			{
				if( phpbb_trim_news_topic( $row['topic_title'], $title_trim ) )
				{
					$row['topic_title'] .= $trim_append_title;
					$row['title_trimmed'] = true;
				}
				else
				{
					$row['title_trimmed'] = false;
				}
			}

			$recent_items[] = $row;
			$topics[] = $row['topic_id'];
		}
	}
	
	return $recent_items;
}

function fetch_news_days( $month, $year )
{
	global $db, $phpbb_root_path, $board_config, $phpEx;

	$interval_begin = mktime( 0,0,0, $month, 1, $year);
	$interval_end   = mktime( 0,0,0, $month+1, 1, $year);

	$sql = 'SELECT
			t.topic_time
		FROM
			' . TOPICS_TABLE     . ' AS t,
			' . NEWS_TABLE  	 . ' AS n
		WHERE
			n.news_id = t.news_id AND
			t.news_id > 0 AND
		    t.topic_time > ' . $interval_begin . ' AND
			t.topic_time < ' . $interval_end;

	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'Could not query forum news information', '', __LINE__, __FILE__, $sql);
	}

	$days = array_fill( 1, 32, 0 );

	while( $row = $db->sql_fetchrow($result) )
	{
		$days[ intval( create_date('j', $row['topic_time'], $board_config['board_timezone'])) ]++;
	}

	$db->sql_freeresult( $result );

	return $days;
}

function fetch_recent_categories( $num_items )
// $num_items: Number of news items to return.
{
	global $db, $phpbb_root_path, $board_config, $phpEx;

	$sql = 'SELECT
			n.*
		FROM
			' . TOPICS_TABLE     . ' AS t,
			' . NEWS_TABLE  	 . ' AS n
		WHERE
			n.news_id = t.news_id AND
			t.news_id > 0
		ORDER BY
			t.topic_time DESC';

	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'Could not query forum news information', '', __LINE__, __FILE__, $sql);
	}

	if( $num_items <= 0 )
	{
		$num_items = 5;
	}

	$cats = array( );
	$recent = array();

	while( $row = $db->sql_fetchrow($result) )
	// Process category
	{
		if( count( $recent ) >= $num_items )
		{
			break;
		}

		if( !in_array( $row['news_id'], $cats ) )
		{
			// We have not yet seen this news category.
			$sql = 'SELECT
					t.topic_replies
				FROM
					' . TOPICS_TABLE     . ' AS t
				WHERE
					t.news_id = ' . $row['news_id'] . ' AND
					t.news_id > 0';

			// Get all topics for the current news category.
			if ( !($result2 = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Could not query forum news information', '', __LINE__, __FILE__, $sql);
			}

			$topic_count = 0;
			$post_count = 0;
			while( $row2 = $db->sql_fetchrow($result2) )
			{
				// Count the topic.
				$topic_count++;

				// Count the original post.
				$post_count++;

				// Add the replies count to the total.
				$post_count += $row2['topic_replies'];
			}

			// Set up path to news category image.
			$row['news_image'] = $phpbb_root_path . $board_config['news_path'] . '/' . $row['news_image'];
			$row['news_image_link'] = '<img src="' . $row['news_image'] . '" border="0" alt="' . $row['news_category'] . '" />';
			$row['post_count'] = $post_count;
			$row['topic_count'] = $topic_count;

			$recent[] = $row;
			$cats[] = $row['news_id'];
		}

	}
	
	return $recent;
}

function fetch_categories( )
{
	global $db, $board_config, $phpbb_root_path;

	$sql = 'SELECT
			n.*
		FROM
			' . NEWS_TABLE   . ' AS n
		WHERE
			1
		ORDER BY
			n.news_category';

	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'Could not query forum news information', '', __LINE__, __FILE__, $sql);
	}

	$cats = array( );

	while( $row = $db->sql_fetchrow($result) )
	// Process category
	{

	// We have not yet seen this news category.
		$sql = 'SELECT
					t.topic_replies
				FROM
					' . TOPICS_TABLE     . ' AS t
				WHERE
					t.news_id = ' . $row['news_id'] . ' AND
					t.news_id > 0';

		// Get all topics for the current news category.
		if ( !($result2 = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Could not query forum news information', '', __LINE__, __FILE__, $sql);
		}

		$topic_count = 0;
		$post_count = 0;

		while( $row2 = $db->sql_fetchrow($result2) )
		{
			// Count the topic.
			$topic_count++;

			// Count the original post.
			$post_count++;
			
			// Add the replies count to the total.
			$post_count += $row2['topic_replies'];
		}

		$row['post_count'] = $post_count;
		$row['topic_count'] = $topic_count;
		$row['news_image'] = $phpbb_root_path . $board_config['news_path'] . '/' . $row['news_image'];
		$row['news_image_link'] = '<img src="' . $row['news_image'] . '" border="0" alt="' . $row['news_category'] . '" />';
		
		$cats[] = $row;
	}
	
	return $cats;
}

function fetch_news_posts(
			$num_items,
			$news_id = 0, 
			$forum_id = 0,
			$news_body_trim = 0, 
			$news_title_trim = 0,
			$trim_append_body = '', 
			$trim_append_title = '',
			$parse_body = true,
			$start = 0 )

// $num_items: Number of news items to return.
// $news_body_trim: Number of characters to trim body to. (0 = disabled)
// $news_title_trim: Number of characters to trim title to. (0 = disabled)
// $trim_append_body: What to attach to the end of a trimed text.
// $trim_append_title: What to attach to the end of a trimed title.
// $news_id: Only retrive news in this category. (0 = disabled)
// $forum_id: Only retrive news in this forum. (0 = disabled)
{
	global $db, $userdata, $phpbb_root_path, $board_config, $phpEx;

	$sql = 'SELECT
			t.*, f.forum_name, f.forum_desc, n.*, p.*, pt.*, 
			u.username, u.user_email
		FROM
			' . TOPICS_TABLE     . ' AS t,
			' . FORUMS_TABLE     . ' AS f,
			' . USERS_TABLE      . ' AS u,
			' . NEWS_TABLE       . ' AS n,
			' . POSTS_TEXT_TABLE . ' AS pt,
			' . POSTS_TABLE      . ' AS p
		WHERE
			t.topic_first_post_id = p.post_id AND
			t.forum_id = f.forum_id AND
			t.topic_first_post_id = pt.post_id AND
			t.topic_poster = u.user_id AND
			t.news_id = n.news_id AND
			t.news_id > 0 ';

	if( $news_id > 0 )
	{
		$sql .= 'AND t.news_id = ' . $news_id . ' ';
	}

	if( $forum_id > 0 )
	{
		$sql .= 'AND t.forum_id = ' . $forum_id . ' ';
	}

	$sql .= 'ORDER BY
			t.topic_time DESC LIMIT ' . $start . ', ' . $num_items;

	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'Could not query forum news information', '', __LINE__, __FILE__, $sql);
	}

	$news_items = array();
	while( $row = $db->sql_fetchrow($result) )
	{
		// Set up path to news category image.
		$row['news_image'] = $phpbb_root_path . $board_config['news_path'] . '/' . $row['news_image'];

		// Trim the post body if needed.
		if( $news_body_trim > 0 )
		{
			if( phpbb_trim_news_text( $row['post_text'], $news_body_trim, $row['bbcode_uid'] ) )
			{
				$row['post_text'] .= $trim_append_body;
				$row['body_trimmed'] = true;
			}
			else
			{
				$row['body_trimmed'] = false;
			}
		}

		// Parese any remaining BBCode, insert smiles, convert urls into links.
		if( $parse_body )
		{
			$row['post_text']  = phpbb_parse_news_text( $row['post_text'], $row['bbcode_uid'], $row['enable_smilies'] );
		}

		// Trim the news title if needed.
		if( $news_title_trim > 0 )
		{
			if( phpbb_trim_news_topic( $row['topic_title'], $news_title_trim ) )
			{
				$row['topic_title'] .= $trim_append_title;
				$row['title_trimmed'] = true;
			}
			else
			{
				$row['title_trimmed'] = false;
			}
		}

		$row['read_more_url'] = $phpbb_root_path . 'news_viewnews.' . $phpEx . '?article=' . $row['topic_id'];
		$row['comments_url'] = $phpbb_root_path . 'viewtopic.' . $phpEx . '?t=' . $row['topic_id'];
		$row['topic_url'] = $phpbb_root_path . 'viewtopic.' . $phpEx . '?t=' . $row['topic_id'];
		$row['poster_url'] = $phpbb_root_path . 'profile.' . $phpEx . '?mode=viewprofile&u=' . $row['topic_poster'];
		$row['forum_url'] = $phpbb_root_path . 'viewforum.' . $phpEx . '?f=' . $row['forum_id'];
		$row['format_topic_time'] = create_date($board_config['default_dateformat'], $row['topic_time'], $board_config['board_timezone']);
		
		$news_items[] = $row;
	}
	
	return $news_items;
}

function fetch_news_post( $topic_id )
// $topic_id: the topic id of a news post.
{
	global $db, $userdata, $phpbb_root_path, $board_config, $phpEx;

	$sql = 'SELECT
			t.*, f.forum_name, f.forum_desc, n.*, p.*, pt.*, 
			u.username, u.user_email
		FROM
			' . TOPICS_TABLE     . ' AS t,
			' . FORUMS_TABLE     . ' AS f,
			' . USERS_TABLE      . ' AS u,
			' . NEWS_TABLE       . ' AS n,
			' . POSTS_TEXT_TABLE . ' AS pt,
			' . POSTS_TABLE      . ' AS p
		WHERE
			t.topic_first_post_id = p.post_id AND
			t.forum_id = f.forum_id AND
			t.topic_first_post_id = pt.post_id AND
			t.topic_poster = u.user_id AND
			t.news_id = n.news_id AND
			t.topic_id = ' . $topic_id;

	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'Could not query forum news information', '', __LINE__, __FILE__, $sql);
	}

	if( $row = $db->sql_fetchrow($result) )
	{
		// Set up path to news category image.
		$row['news_image'] = $phpbb_root_path . $board_config['news_path'] . '/' . $row['news_image'];

		// Parese any remaining BBCode, insert smiles, convert urls into links.
		$row['post_text']  = phpbb_parse_news_text( $row['post_text'], $row['bbcode_uid'], $row['enable_smilies'] );

		$row['comments_url'] = $phpbb_root_path . 'viewtopic.' . $phpEx . '?t=' . $row['topic_id'];
		$row['topic_url'] = $phpbb_root_path . 'viewtopic.' . $phpEx . '?t=' . $row['topic_id'];
		$row['poster_url'] = $phpbb_root_path . 'profile.' . $phpEx . '?mode=viewprofile&u=' . $row['topic_poster'];
		$row['forum_url'] = $phpbb_root_path . 'viewforum.' . $phpEx . '?f=' . $row['forum_id'];
		$row['format_topic_time'] = create_date($board_config['default_dateformat'], $row['topic_time'], $board_config['board_timezone']);

		$news_items[] = $row;
	}
	
	return $news_items;
}

function fetch_news_count( $news_id )
{

	global $db;
	
	$sql = 'SELECT
				COUNT(t.news_id) AS num_posts
			FROM
				' . TOPICS_TABLE . ' AS t
			WHERE
				t.news_id > 0';

	if( $news_id > 0 )
	{
		$sql .= ' AND t.news_id = ' . $news_id;
	}

	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, "Could not obtain limited news count information", '', __LINE__, __FILE__, $sql);
	}

	$total = ( $row = $db->sql_fetchrow($result) ) ? intval($row['num_posts']) : 0;

	return $total;
}

/*
#######################################################################
##                                                                   ##
## Borrowed from "fetch_all_mod"                                     ##
##                                                                   ##
##                                                                   ##
## phpbb_parse_news_text()                                           ##
## ----------------------------------------------------------------- ##
## Parses text according to phpBB (BBCode, smilies, etc).            ##
##                                                                   ##
## PARAMETER                                                         ##
##                                                                   ##
##     text                                                          ##
##         the text to be parsed                                     ##
##     bbcode_uid                                                    ##
##         bbcode identifier                                         ##
##     enable_smilies                                                ##
##         if true all smilies will be parsed with their icon        ##
##         otherwise you will only see the smilie code               ##
##     enable_images                                                 ##
##         if true all images will be left untouched otherwise all   ##
##         images will be replaced with the text in the next         ##
##         parameter                                                 ##
##     replace_images                                                ##
##         text to replace images with                               ##
##                                                                   ##
#######################################################################
*/
function phpbb_parse_news_text(	$text = null,
                          	$bbcode_uid = null,
                          	$enable_smilies = true,
                          	$enable_images = true,
                          	$replace_images = '')
{
	global $board_config, $phpbb_root_path;

    if (!$text)
    {
        return;
    }

    stripslashes($text);

    if (!$enable_images)
    {
        if ($replace_images)
        {
            $replacement = '[url=\\1]' . $replace_images . '[/url]';
        }
        else
        {
            $replacement = '';
        }
        $text = preg_replace("#\[img:$bbcode_uid\](.*?)\[/img:$bbcode_uid\]#si",
                             $replacement, $text);
    }

    //
    // parse bbcode
    //

    $text = bbencode_second_pass($text, $bbcode_uid);

    //
    // parse smilies if requested
    //

    if ($enable_smilies == 1)
    {
        $text = smilies_pass($text);

        //
        // need to overwrite the smilie path since we might not be within
        // the phpBB directory
        //

        $text = preg_replace("/images\/smiles/", $phpbb_root_path . $board_config['smilies_path'], $text);
    }

    //
    // parse url's
    //

    $text = make_clickable($text);

    //
    // change newlines to HTML
    //

    $text = str_replace("\n", "\n<br />\n", $text);

    return $text;
} // end func phpbb_parse_text

/*
#######################################################################
##                                                                   ##
## Borrowed from "fetch_all_mod"				     ##
##                                                                   ##
## phpbb_trim_news_text()                                            ##
## ----------------------------------------------------------------- ##
## This function can trim a text by number of characters or the      ##
## first appearence of a character combination.                      ##
##                                                                   ##
## PARAMETER                                                         ##
##                                                                   ##
##     text                                                          ##
##         contains the text which should be trimmed                 ##
##     is_trimmed                                                    ##
##         will be false if no trimming has been done and true if    ##
##         the text has been trimmed                                 ##
##     character                                                     ##
##         a character combination ('<br />')                        ##
##     number                                                        ##
##         a number of characters ('150')                            ##
##                                                                   ##
#######################################################################
*/
function phpbb_trim_news_text( &$text, $number = 0, $bbcode_uid )
{
    if ($number != 0 and strlen($text) > $number)
    {
		stripslashes($text);
		$text = bbencode_news_strip( $text, $bbcode_uid );
		$text = substr( $text, 0, $number);

		return true;
    }
    else
    {
    	return false;
    }
} // end func phpbb_trim_news_text

function phpbb_trim_news_topic( &$text, $number = 0)
{
    if ($number != 0 and strlen($text) > $number)
    {
 	stripslashes($text);
	$text = substr( $text, 0, $number);
	
	return true;
    }
    else
    {
    	return false;
    }
} // end func phpbb_trim_news_text

//
// Function strip all BBcodes (borrowed from Mouse Hover Topic Preview MOD)
//
function bbencode_news_strip($text, $uid)
{
	// pad it with a space so we can distinguish between FALSE and matching the 1st char (index 0).
	// This is important; bbencode_quote(), bbencode_list(), and bbencode_code() all depend on it.
	$text = " " . $text;

	// First: If there isn't a "[" and a "]" in the message, don't bother.
	if (! (strpos($text, "[") && strpos($text, "]")) )
	{
		// Remove padding, return.
		$text = substr($text, 1);
		return $text;
	}

	// [CODE] and [ /CODE ] for posting code (HTML, PHP, C etc etc) in your posts.
	$text = str_replace("[code:1:$uid]","", $text);
	$text = str_replace("[/code:1:$uid]", "", $text);
	$text = str_replace("[code:$uid]", "", $text);
	$text = str_replace("[/code:$uid]", "", $text);

	// [QUOTE] and [/QUOTE] for posting replies with quote, or just for quoting stuff.
	$text = str_replace("[quote:1:$uid]","", $text);
	$text = str_replace("[/quote:1:$uid]", "", $text);
	$text = str_replace("[quote:$uid]", "", $text);
	$text = str_replace("[/quote:$uid]", "", $text);
	// New one liner to deal with opening quotes with usernames...
	// replaces the two line version that I had here before..
	$text = preg_replace("/\[quote:$uid=(?:\"?([^\"]*)\"?)\]/si", "", $text);
	$text = preg_replace("/\[quote:1:$uid=(?:\"?([^\"]*)\"?)\]/si", "", $text);
	
	// [list] and [list=x] for (un)ordered lists.
	// unordered lists
	$text = str_replace("[list:$uid]", "", $text);
	// li tags
	$text = str_replace("[*:$uid]", "", $text);
	// ending tags
	$text = str_replace("[/list:u:$uid]", "", $text);
	$text = str_replace("[/list:o:$uid]", "", $text);
	// Ordered lists
	$text = preg_replace("/\[list=([a1]):$uid\]/si", "", $text);

	// colours
	$text = preg_replace("/\[color=(\#[0-9A-F]{6}|[a-z]+):$uid\]/si", "", $text);
	$text = str_replace("[/color:$uid]", "", $text);

	// url #2
	$text = str_replace("[url]","", $text);
	$text = str_replace("[/url]", "", $text);

	// url /\[url=([a-z0-9\-\.,\?!%\*_\/:;~\\&$@\/=\+]+)\](.*?)\[/url\]/si
	$text = preg_replace("/\[url=([a-z0-9\-\.,\?!%\*_\/:;~\\&$@\/=\+]+)\]/si", "", $text);
	$text = str_replace("[/url:$uid]", "", $text);

	// img
	$text = str_replace("[img:$uid]","", $text);
	$text = str_replace("[/img:$uid]", "", $text);

	// email
	$text = str_replace("[email:$uid]","", $text);
	$text = str_replace("[/email:$uid]", "", $text);

	// size
	$text = preg_replace("/\[size=([\-\+]?[1-2]?[0-9]):$uid\]/si", "", $text);
	$text = str_replace("[/size:$uid]", "", $text);
	
	// align
	$text = preg_replace("/\[align=(left|right|center|justify):$uid\]/si", "", $text);
	$text = str_replace("[/align:$uid]", "", $text);

	// [b] and [/b] for bolding text.
	$text = str_replace("[b:$uid]","", $text);
	$text = str_replace("[/b:$uid]", "", $text);

	// [u] and [/u] for underlining text.
	$text = str_replace("[u:$uid]", "", $text);
	$text = str_replace("[/u:$uid]", "", $text);

	// [i] and [/i] for italicizing text.
	$text = str_replace("[i:$uid]", "", $text);
	$text = str_replace("[/i:$uid]", "", $text);

	// Remove our padding from the string..
	$text = substr($text, 1);

	return $text;
}
?>
